//---------------------------------------------------------------------------
#include "TreeWriter.h"
#include "TreePopulation.h"
#include "SimManager.h"
#include <fstream.h>
//---------------------------------------------------------------------------
/*/////////////////////////////////////////////////////////////////////////////
 Constructor()

  Edit history:
  -------------
  April 28, 2004 - Submitted in beta version (LEM)
/////////////////////////////////////////////////////////////////////////////*/
clTreeWriter::clTreeWriter(clSimManager *p_oSimManager) :
     clBehaviorBase(p_oSimManager), clWorkerBase(p_oSimManager) {

  //Allowed file types
  m_iNumAllowedTypes = 2;
  mp_iAllowedFileTypes = new int[m_iNumAllowedTypes];
  mp_iAllowedFileTypes[0] = parfile;
  mp_iAllowedFileTypes[1] = detailed_output;

  //Versions
  m_fVersionNumber = 1;
  m_fMinimumVersionNumber = 1;

  strcpy(m_cNameString, "treewriter");
}
//---------------------------------------------------------------------------

/*/////////////////////////////////////////////////////////////////////////////
 GetData()

 Edit history:
 -------------
 April 28, 2004 - Submitted in beta version (LEM)

/////////////////////////////////////////////////////////////////////////////*/
void clTreeWriter::GetData(DOMDocument *p_oDoc) {
  clPopulationBase *p_oTemp = mp_oSimManager->GetPopulationObject("treepopulation");
  mp_oPop = (clTreePopulation*) p_oTemp;

  //Write out heights
/*  clTreeSearch *p_oAllTrees;
  clTree *p_oTree;
  float fHeight;
  short int **p_iHeights, //#species by height divisions
            iNumSpecies = mp_oPop->GetNumberOfSpecies(),
            i, j, iSp, iTp;

  p_iHeights = new short int*[iNumSpecies];
  for (i = 0; i < iNumSpecies; i++) {
    p_iHeights[i] = new short int[6];
    for (j = 0; j < 6; j++)
      p_iHeights[i][j] = 0;
  }

  p_oAllTrees = mp_oPop->Find("all");
  p_oTree = p_oAllTrees->NextTree();

  while (p_oTree) {
    iSp = p_oTree->GetSpecies();
    iTp = p_oTree->GetType();
    p_oTree->GetValue(mp_oPop->GetHeightCode(iSp, iTp), &fHeight);

    if (fHeight < 10)
      p_iHeights[iSp][0]++;
    else if (fHeight >= 10 && fHeight < 15)
      p_iHeights[iSp][1]++;
    else if (fHeight >= 15 && fHeight < 20)
      p_iHeights[iSp][2]++;
    else if (fHeight >= 20 && fHeight < 25)
      p_iHeights[iSp][3]++;
    else if (fHeight >= 25 && fHeight < 30)
      p_iHeights[iSp][4]++;
    else
      p_iHeights[iSp][5]++;

    p_oTree = p_oAllTrees->NextTree();
  }

  //Write it out
  fstream out("NewHeights.xls", ios::out | ios::trunc);
  out << "Sp\t0-10m\t10-15m\t15-20m\t20-25m\t25-30m\t>30m";

  for (i = 0; i < iNumSpecies; i++) {
    out << "\n" << i;
    for (j = 0; j < 6; j++) {
      out << "\t" << p_iHeights[i][j];
    }
  }

  out.close();   */

  Action();
}
//---------------------------------------------------------------------------

/*/////////////////////////////////////////////////////////////////////////////
Action()
Edit history:
-------------
April 28, 2004 - Submitted in beta version (LEM)
/////////////////////////////////////////////////////////////////////////////*/
void clTreeWriter::Action() {

  clTreeSearch *p_oAllTrees;
  clTree *p_oTree;
  float fVal;
  fstream out("TreeList.xls", ios::out | ios::trunc);
  out << "Tree list for parameter file " << mp_oSimManager->GetParFilename()
      << ", Timestep " << mp_oSimManager->GetCurrentTimestep()
      << "\nX\tY\tType\tSpecies\n";

  p_oAllTrees = mp_oPop->Find("all");
  p_oTree = p_oAllTrees->NextTree();
  while (p_oTree) {

    p_oTree->GetValue(mp_oPop->GetXCode(p_oTree->GetSpecies(), p_oTree->GetType()), &fVal);
    out << fVal;

    p_oTree->GetValue(mp_oPop->GetYCode(p_oTree->GetSpecies(), p_oTree->GetType()), &fVal);

    out << "\t" << fVal << "\t" << p_oTree->GetType() << "\t"
        << p_oTree->GetSpecies() << "\n";

    p_oTree = p_oAllTrees->NextTree();
  }

}
//---------------------------------------------------------------------------
